## mingw-w64-quantum-espresso-7.4-1.src.tar.zst

=== COUPLE/CMakeLists.txt ===
set(src_couple
    src/libpwscf.f90
    src/libcpv.f90
    src/libqemod.f90)
qe_enable_cuda_fortran("${src_couple}")

qe_add_library(qe_couple ${src_couple})
target_link_libraries(qe_couple
    PRIVATE
        qe_modules
        qe_lax
	    qe_fftx
        qe_cpv)

###########################################################

qe_install_targets(qe_couple)

add_custom_target(couple
    DEPENDS
        qe_couple
    COMMENT
        "library interface for coupling to external codes")

=== CPV/CMakeLists.txt ===
set(src_cpv
    src/berryion.f90
    src/bforceion.f90
    src/cell_nose.f90
    src/cg.f90
    src/cg_sub.f90
    src/chargedensity.f90
    src/cp_autopilot.f90
    src/cp_emass.f90
    src/cp_interfaces.f90
    src/cp_restart_new.f90
    src/cplib.f90
    src/cpr_mod.f90
    src/cpr.f90
    src/dealloc.f90
    src/dforceb.f90
    src/efermi.f90
    src/efield.f90
    src/eigs0.f90
    src/electrons.f90
    src/electrons_nose.f90
    src/energies.f90
    src/ensemble_dft.f90
    src/environ_cp_module.f90
    src/exch_corr.f90
    src/exx_cg.f90
    src/exx_es.f90
    src/exx_gs.f90
    src/exx_module.f90
    src/exx_pair.f90
    src/exx_psi.f90
    src/exx_vofr.f90
    src/forces.f90
    src/fromscra.f90
    src/gram.f90
    src/gtable.f90
    src/init.f90
    src/init_run.f90
    src/inner_loop_cold.f90
    src/input.f90
    src/ions_nose.f90
    src/ions_positions.f90
    src/ksstates.f90
    src/ldaU_cp.f90
    src/ldaU.f90
    src/ldaUpen.f90
    src/mainvar.f90
    src/cpr_loop.f90
    src/cplib_meta.f90
    src/metaxc.f90
    src/modules.f90
    src/move_electrons.f90
    src/newd.f90
    src/nl_base.f90
    src/nlcc.f90
    src/ortho_base.f90
    src/ortho.f90
    src/phasefactor.f90
    src/plugin_add_potential.f90
    src/plugin_clean.f90
    src/plugin_clock.f90
    src/plugin_energy.f90
    src/plugin_ext_forces.f90
    src/plugin_get_potential.f90
    src/plugin_init_base.f90
    src/plugin_init_cell.f90
    src/plugin_initialization.f90
    src/plugin_init_ions.f90
    src/plugin_int_forces.f90
    src/plugin_print_energies.f90
    src/plugin_print_info.f90
    src/plugin_read_input.f90
    src/plugin_utilities.f90
    src/potentials.f90
    src/pres_ai_mod.f90
    src/print_out.f90
    src/problem_size.f90
    src/pseudo_base.f90
    src/pseudopot.f90
    src/pseudopot_sub.f90
    src/qmatrixd.f90
    src/qqberry.f90
    src/restart.f90
    src/restart_sub.f90
    src/runcp.f90
    src/sic.f90
    src/smallbox.f90
    src/smallbox_grid.f90
    src/smallbox_gvec.f90
    src/smallbox_subs.f90
    src/smallbox_lib.f90
    src/spline.f90
    src/spinsq.f90
    src/stop_run.f90
    src/stress.f90
    src/vol_clu.f90
    src/vofrho.f90
    src/wannier_base.f90
    src/wannier.f90
    src/wave.f90
    src/wave_base.f90
    src/wave_types.f90
    src/wf.f90
    src/entropy.f90)
qe_enable_cuda_fortran("${src_cpv}")

qe_add_library(qe_cpv ${src_cpv})
target_link_libraries(qe_cpv
    PRIVATE
        qe_lax
        qe_modules
        qe_fftx
        qe_upflib
        qe_openmp_fortran
        qe_mpi_fortran
        qe_xclib
        qe_device_lapack
        qe_devxlib
     PUBLIC 
        qe_openacc_fortran)

if ("legacy" IN_LIST QE_ENABLE_PLUGINS) 
  target_compile_definitions(qe_cpv PUBLIC __LEGACY_PLUGINS)
endif() 
###########################################################
# cp.x
###########################################################
set(src_cp_x src/cprstart.f90)
qe_enable_cuda_fortran("${src_cp_x}")
qe_add_executable(qe_cpv_exe ${src_cp_x})
set_target_properties(qe_cpv_exe 
    PROPERTIES 
        OUTPUT_NAME cp.x)
target_link_libraries(qe_cpv_exe
    PRIVATE
        qe_modules
        qe_lax
        qe_cpv
        qe_xclib)

###########################################################
# manycp.x
###########################################################
set(src_manycp_x src/manycp.f90)
qe_enable_cuda_fortran("${src_manycp_x}")
qe_add_executable(qe_cpv_manycp_exe ${src_manycp_x})
set_target_properties(qe_cpv_manycp_exe 
    PROPERTIES 
        OUTPUT_NAME manycp.x)
target_link_libraries(qe_cpv_manycp_exe
    PRIVATE
        qe_lax
        qe_modules
        qe_cpv
        qe_xclib)

###########################################################
# cppp.x
###########################################################
set(src_cppp_x src/cppp.f90)
qe_add_executable(qe_cpv_cppp_exe ${src_cppp_x})
set_target_properties(qe_cpv_cppp_exe 
    PROPERTIES 
        OUTPUT_NAME cppp.x)
target_link_libraries(qe_cpv_cppp_exe
    PRIVATE
        qe_modules
        qe_cpv
        qe_xclib)

###########################################################
# wfdd.x
###########################################################
set(src_wfdd_x src/wfdd.f90)
qe_add_executable(qe_cpv_wfdd_exe ${src_wfdd_x})
set_target_properties(qe_cpv_wfdd_exe 
    PROPERTIES 
        OUTPUT_NAME wfdd.x)
target_link_libraries(qe_cpv_wfdd_exe
    PRIVATE
        qe_modules
        qe_cpv
        qe_xclib
        qe_lapack)

###########################################################

qe_install_targets(
    # Libraries
    qe_cpv
    # Exacutables
    qe_cpv_exe
    qe_cpv_manycp_exe
    qe_cpv_cppp_exe
    qe_cpv_wfdd_exe)

add_custom_target(cp
    DEPENDS
        qe_cpv_exe
        qe_cpv_manycp_exe
        qe_cpv_cppp_exe
        qe_cpv_wfdd_exe
    COMMENT
        "CP code: Car-Parrinello molecular dynamics")

=== KCW/CMakeLists.txt ===
add_subdirectory(src)
add_subdirectory(PP)

###########################################################

qe_install_targets(qe_kcw qe_kcw_exe qe_kcwpp_sh_exe qe_kcwpp_interp_exe qe_kcwpp_merge_wann_exe)

add_custom_target(
    kcw
    DEPENDS pw qe_pp_pw2wannier90_exe w90 qe_kcw_exe qe_kcwpp_sh_exe qe_kcwpp_interp_exe qe_kcwpp_merge_wann_exe
    COMMENT "Koopmans spectral functionals")

=== UtilXlib/CMakeLists.txt ===
set(src_util
    clocks_handler.f90
    divide.f90
    data_buffer.f90
    error_handler.f90
    find_free_unit.f90
    fletcher32_mod.f90
    mem_counter.f90
    mp.f90
    mp_base.f90
    mp_bands_util.f90
    nvtx_wrapper.f90
    parallel_include.f90
    print_mem.f90
    util_param.f90
    thread_util.f90
    clib_wrappers.f90
    export_gstart_2_solvers.f90
    set_mpi_comm_4_solvers.f90
    # GPU
    mp_base_gpu.f90)
qe_enable_cuda_fortran("${src_util}")
qe_add_library(qe_utilx ${src_util})

set(src_util_c
    cptimer.c
    copy.c
    c_mkdir.c
    eval_infix.c
    fletcher32.c
    md5.c
    md5_from_file.c
    memstat.c
    memusage.c
    ptrace.c)
add_library(qe_utilx_c ${src_util_c})
target_link_libraries(qe_utilx
    PUBLIC
        qe_utilx_c # cclock is exposed by the mytime module in clocks_handler
        qe_ext_prof_tool # to pass link options, PUBLIC is needed.
        qe_mpi_fortran
    PRIVATE
        qe_openmp_fortran)

qe_install_targets(qe_utilx qe_utilx_c)

# Feature checks
check_function_exists(mallinfo HAVE_MALLINFO)
if(HAVE_MALLINFO)
    target_compile_definitions(qe_utilx_c PRIVATE HAVE_MALLINFO)
endif()

set(src_device_lapack
    device_helper.f90)
qe_enable_cuda_fortran("${src_device_lapack}")
qe_add_library(qe_device_lapack ${src_device_lapack})
target_link_libraries(qe_device_lapack
    PRIVATE
        qe_openacc_fortran
        qe_lapack
        qe_openmp_fortran
        qe_mpi_fortran)

qe_install_targets(qe_device_lapack)

###########################################################
# tests
###########################################################
if(QE_ENABLE_TEST)
    set(src_util_tests
        tests/tester.f90
        tests/utils.f90
        tests/mp_world.f90)
    qe_enable_cuda_fortran("${src_util_tests}")

    qe_add_library(qe_utilx_tests ${src_util_tests})
    target_link_libraries(qe_utilx_tests
        PRIVATE
            qe_utilx
            qe_mpi_fortran)

    qe_install_targets(qe_utilx_tests)

    set(source_names
        test_offload_macros
        test_mp_count_nodes
        test_mp_bcast_i1
        test_mp_bcast_iv
        test_mp_bcast_im
        test_mp_bcast_it
        test_mp_bcast_iv_buffer
        test_mp_bcast_lv_buffer
        test_mp_bcast_rv_buffer
        test_mp_max_iv_buffer
        test_mp_max_rv_buffer
        test_mp_min_iv_buffer
        test_mp_min_rv_buffer
        test_mp_sum_iv_buffer
        test_mp_sum_rv_buffer)

    if(QE_ENABLE_CUDA)
        set(source_names ${source_names}
            test_mp_bcast_i1_gpu
            test_mp_bcast_iv_gpu
            test_mp_bcast_im_gpu
            test_mp_bcast_it_gpu
            test_mp_bcast_i4d_gpu
            test_mp_bcast_r4d_gpu
            test_mp_bcast_c4d_gpu
            test_mp_bcast_c5d_gpu
            test_mp_bcast_r5d_gpu
            test_mp_bcast_c6d_gpu
            test_mp_bcast_iv_buffer_gpu
            test_mp_bcast_lv_buffer_gpu
            test_mp_bcast_rv_buffer_gpu
            test_mp_max_iv_buffer_gpu
            test_mp_max_rv_buffer_gpu
            test_mp_min_iv_buffer_gpu
            test_mp_min_rv_buffer_gpu
            test_mp_sum_iv_buffer_gpu
            test_mp_sum_rv_buffer_gpu)
    endif()

    # TODO rename all sources *.f90 -> *.F90
    FOREACH(NAME ${source_names})
        set(src_test tests/${NAME}.f90)
        qe_enable_cuda_fortran("${src_test}")
        string(REPLACE "test_" "test_qe_utilx_" TGT_NAME ${NAME})
        qe_add_executable(${TGT_NAME} ${src_test})
        set_target_properties(${TGT_NAME} 
            PROPERTIES
                OUTPUT_NAME ${TGT_NAME}.x 
                RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin)
        target_link_libraries(${TGT_NAME}
            PRIVATE
                qe_utilx
                qe_utilx_tests
                qe_mpi_fortran)
        add_unit_test(${TGT_NAME} 1 1 $<TARGET_FILE:${TGT_NAME}>)
    ENDFOREACH(NAME)
    target_link_libraries(test_qe_utilx_offload_macros
        PRIVATE
            qe_openacc_fortran
            qe_openmp_fortran)
endif()

=== UtilXlib/Makefile ===
# Makefile for DAVID

include ../make.inc

# location of needed modules and included files (if any)
MODFLAGS=$(MOD_FLAG).

UTIL = clib_wrappers.o \
clocks_handler.o \
cptimer.o \
copy.o \
c_mkdir.o \
device_helper.o \
divide.o \
data_buffer.o \
eval_infix.o \
error_handler.o \
export_gstart_2_solvers.o \
find_free_unit.o \
fletcher32_mod.o \
fletcher32.o \
md5.o \
md5_from_file.o \
memstat.o \
memusage.o \
mem_counter.o \
mp.o \
mp_base.o \
mp_base_gpu.o \
mp_bands_util.o \
parallel_include.o \
print_mem.o\
ptrace.o\
set_mpi_comm_4_solvers.o \
util_param.o \
thread_util.o \
nvtx_wrapper.o 

all : libutil.a


libutil.a:  $(UTIL)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L *.x

include make.depend

=== test-suite/Makefile ===

#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License. See the file `License' in the root directory
# of the present distribution.

include ./ENVIRONMENT

default :
	@echo 'To run Quantum ESPRESSO test-suite, type at the shell prompt:'
	@echo ' '
	@echo '  make target'
	@echo ' '
	@echo 'where <target> identifies an action'
	@echo ' run-tests-XX [NPROCS=N]        : run tests [optionally, on N processors]'
	@echo ' for XX=pw, cp, ph, pp, hp, tddfpt, kcw, all_currents, epw, zg, xsd-pw'
	@echo ' run-tests [NPROCS=N]           : run all tests above (except the last four)'
	@echo ' run-custom-test testdir=DIR [NPROCS=N]: run test in DIR only'
	@echo ' compare                     : compare last output with reference'
	@echo ' pseudo                      : download needed PPs into ESPRESSO_PSEUDO'
	@echo ' clean                       : clean stdout/sderr of all tests'
	@echo ' '
	@echo 'For additional advanced commands and settings please manually inspect'
	@echo 'ENVIRONMENT and Makefile files'

prolog :
	@sed "s|XXXXXX|$(ESPRESSO_ROOT)|g" < userconfig.tmp > userconfig
	@if ! test -d $(ESPRESSO_TMPDIR); then mkdir $(ESPRESSO_TMPDIR); fi

pseudo :
	@./check_pseudo.sh pw_
	@./check_pseudo.sh cp_
	@./check_pseudo.sh epw_
	@./check_pseudo.sh tddfpt_
	@./check_pseudo.sh hp_
	@./check_pseudo.sh ph_
	@./check_pseudo.sh QEHeat_
	@./check_pseudo.sh kcw_
	@./check_pseudo.sh oscdft_

run-tests : run-tests-pw run-tests-cp run-tests-ph run-tests-pp run-tests-hp run-tests-tddfpt run-tests-kcw

run-tests-cp : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=cp_all

run-tests-pw : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=pw_all

run-tests-ph : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=ph_all

run-tests-epw : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=epw_all

run-tests-zg : prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=zg_all

run-tests-hp : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=hp_all

run-tests-pp : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=pp_all

run-tests-tddfpt : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=tddfpt_all

run-tests-image : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=image_all

run-tests-kcw : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose  --category=kcw_all

run-tests-all_currents : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=all_currents_all

run-tests-oscdft : prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=oscdft_all

run-travis : clean prolog pseudo
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=epw_base

run-custom-test : prolog pseudo
	@if test -d $(testdir); then \
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --verbose --category=$(testdir) ; fi

run-tests-xsd-pw : prolog pseudo
	cd xsd_pw ; for file in ./*.in ; do \
	echo "Running using $$file" ; \
		env QE_USE_MPI=$(NPROCS) ../run-pw.sh -in $$file &> $$file.out ; \
		python ../validate_xsd_pw.py $$file; \
    done ; cd ..

create-reference-cp : pseudo prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --category=cp_all make-benchmarks

create-reference-pw : pseudo prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --category=pw_all make-benchmarks

create-reference-epw : pseudo prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --category=epw_all make-benchmarks

create-reference-all_currents : pseudo prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --category=all_currents_all make-benchmarks

create-reference-oscdft : pseudo prolog
	env QE_USE_MPI=$(NPROCS) ${TESTCODE_DIR}/bin/testcode.py --category=oscdft_all make-benchmarks

compare : compare-cp compare-pw compare-ph compare-epw compare-tddfpt compare-hp compare-all_currents

compare-cp : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=cp_all  --verbose compare 2>&1 | tee out.CP.`date +%Y%m%d_%H%M%S`

compare-pw : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=pw_all  --verbose compare 2>&1 | tee out.PW.`date +%Y%m%d_%H%M%S`

compare-ph : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=ph_all  --verbose compare 2>&1 | tee out.PH.`date +%Y%m%d_%H%M%S`

compare-epw : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=epw_all  --verbose compare 2>&1 | tee out.EPW.`date +%Y%m%d_%H%M%S`

compare-tddfpt : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=tddfpt_all  --verbose compare 2>&1 | tee out.TDDFPT.`date +%Y%m%d_%H%M%S`

compare-hp : prolog
	${TESTCODE_DIR}/bin/testcode.py --category=hp_all  --verbose compare 2>&1 | tee out.HP.`date +%Y%m%d_%H%M%S`

compare-all_currents : prolog pseudo
	${TESTCODE_DIR}/bin/testcode.py --category=all_currents_all  --verbose compare 2>&1 | tee out.ALL_CURRENTS.`date +%Y%m%d_%H%M%S`


clean:
# output files
	@rm -rf pw_*/test* ph_*/test* cp_*/test* hp_*/test* pp_*/test* epw_*/test* zg_*/test* tddfpt_*/test* kcw_*/test*
# error files
	@rm -rf pw_*/CRASH ph_*/CRASH* cp_*/CRASH hp_*/CRASH pp_*/CRASH epw_*/CRASH zg_*/CRASH tddfpt_*/CRASH kcw_*/CRASH
# temporary input files
	@rm -rf pw_*/input_tmp.in ph_*/input_tmp.in cp_*/input_tmp.in hp_*/input_tmp.in pp_*/input_tmp.in epw_*/input_tmp.in zg_*/input_tmp.in tddfpt_*/input_tmp.in kcw_*/input_tmp.in
# pwscf data files
	@rm -rf pw_*/pwscf.* ph_*/pwscf.* pp_*/pwscf.* epw_*/pwscf.*
# cp data files
	@rm -rf cp_si/si_*.* cp_o2/o2_*.* cp_h2o*/h2o_*.* cp_sio2/sio2_*.*
	@rm -rf cp_si/si.??? cp_o2/o2.??? cp_h2o*/h2o.??? cp_sio2/sio2.???
# Special case for 'pw_vc-relax' test-case
	@rm -f pw_vc-relax/ave pw_vc-relax/e pw_vc-relax/tv pw_vc-relax/p pw_vc-relax/eal pw_vc-relax/avec
# Special case for 'noexe_langevin' test-case
	@rm -f noexe_langevin/trajectory-pwscf.xyz
# Special case for PH
	@for x in `find ph_* -name "*dyn"`; do rm -rf $$x; done
# Cleaning PH final files
	@rm -rf ph_*/_ph0 ph_*/*.save ph_*/*.xml ph_*/a2F.* ph_*/*.dyn? ph_*/*.dyn?? ph_*/alpha2F.dat \
		ph_*/dyna2F ph_*/elph.gamma* ph_*/gam.lines ph_*/lambda ph_*/lambda.dat \
		ph_*/elph_dir ph_*/Al444.* ph_*/matdyn.modes ph_*/phonon.dos
	@rm -rf ph_metal/aluminum.* ph_base/carbon.* ph_base/nickel.* ph_base/nickelpaw.* ph_base/silicon.* \
	        ph_U_metal_us/iron.* ph_U_insulator_us/bn.* ph_U_metal_paw/nickel.* ph_U_insulator_paw/bn.*
	@rm -rf ph_*/*.wfc* ph_*/*.hub*
	@rm -rf ph_1d/dynmat.axsf ph_1d/dynmat.mold
	@rm -rf ph_2d/bn.frc ph_2d/bn.frq ph_2d/bn.frq.gp
# Special case for PH dvscf_q2r
	@rm -rf ph_interpol*/w_pot/ ph_interpol*/*.dyn*.elph.* ph_interpol*/*.dyn.freq
# Special case for PH ahc
	@rm -rf ph_ahc*/wpot*/ ph_ahc*/selfen_*.dat ph_ahc*/diam.modes? ph_ahc*/*.ifc ph_ahc*/ahc_dir*
# Cleaning HP final files
	@rm -rf hp_*/HP hp_*/*hub* hp_*/*.xml hp_*/*.wfc* hp_*/*.save hp_*/*Hubbard_parameters* \
		hp_*/*HubbardV* hp_*/*mix* hp_*/*parameters.out
# Cleaning KCW final files
	@rm -rf	kcw_*/out kcw_*/*.nnkp kcw_*/*.wout kcw_*/*.amn kcw_*/*.mmn kcw_*/*.eig kcw_*/*band* kcw_*/*chk \
                kcw_*/*.dat kcw_*/*.xyz kcw_*/*.mat 
# Cleaning EPW final files
	@rm -rf epw_*/_ph0 epw_*/*.save epw_*/*.wfc* epw_*/*.dyn* \
		epw_*/*.qdos_* epw_*/*.P epw_*/*.wout epw_*/crystal.fmt epw_*/*.pade* \
		epw_*/*.epmat_wanep epw_*/*.kgmap epw_*/*.nnkp epw_*/*.epmatwp* \
		epw_*/*.acon_iso_* epw_*/*.a2f* epw_*/*.phdos* epw_*/*.lambda \
		epw_*/*.kmap epw_*/*.lambda_k_pairs epw_*/*.ukk epw_*/*.imag_aniso* \
		epw_*/*.win epw_*/*.imag_iso* epw_*/*.chk epw_*/*.freq  \
		epw_*/*.epmatwp epw_*/*.epwane epw_*/*.ephmat epw_*/epsilon2* \
		epw_*/*.H epw_*/*.epb* epw_*/*self epw_*/*.res* epw_*/*.01 \
		epw_*/*.kpt epw_*/*.gnu epw_*/*.lambda_FS epw_*/*.sigma_restart* \
		epw_*/specfun* epw_*/linewidth.*  epw_*/*.tau_restart* epw_*/lambda.phself* \
		epw_*/*_elcond_* epw_*/fort.* epw_*/decay.* epw_*/scattering_rate* \
		epw_*/*.fc.* epw_*/*_band.dat epw_*/*F_restart* epw_*/*F_restart_CB* \
		epw_*/*.mmn epw_*/*.epmatkq* epw_*/*.epmatkqcb* epw_*/sparse* \
		epw_*/*.Fin_restart* epw_*/*.Fin_restartcb* epw_*/*.acon_iso_* \
		epw_*/*.bvec epw_*/*.fc epw_*/*.xml epw_*/*.labelinfo.dat \
		epw_*/Fepmatkq1 epw_*/Fepmatkqcb1 epw_*/Fsparse epw_*/Fsparsecb \
		epw_*/inv_taucb_tmp epw_*/inv_tau_tmp epw_*/*.cube epw_*/EPW.bib \
		epw_*/*_hr.dat epw_*/*_wsvec.dat epw_*/epwdata.fmt epw_*/IBTEvel_sup.fmt \
		epw_*/inv_taucb.fmt epw_*/inv_tau.fmt epw_*/restart.fmt epw_*/vmedata.fmt \
		epw_*/selecq.fmt epw_*/dmedata.fmt epw_*/band.eig epw_*/ksdata.fmt \
		epw_*/inv_tau_freq.fmt epw_*/inv_taucb_freq.fmt epw_*/inv_taucb_mode.fmt \
		epw_*/mobility_nk.fmt epw_*/mobility_nuq.fmt epw_*/inv_tau_mode.fmt \
		epw_*/wigner.fmt epw_*/*.dos epw_*/*.dmat* epw_*/*.qmap epw_*/*.dwmatwe* \
		epw_*/*.symk epw_*/*.sthmatwe* epw_*/*.xqc* epw_*/*.dgmatwe* epw_*/*.cpmew* \
		epw_*/elself_wfpt_sup.* epw_*/*.bak

# Special cases for EPW
	@rm -rf epw_base/save epw_super/save epw_super/*.bands.*.dat epw_pl/save/ epw_polar/save/ \
		epw_trev/save epw_trev_uspp/save epw_trev_paw/save \
		epw_mob/save epw_mob_ibte/save epw_mob_ibte_sym/save epw_mob_polar/save \
		epw_qdpt/save epw_2D/save epw_hall/save epw_qdpt/*.dat epw_wfpt/save \
		epw_wfpt/matdyn.modes epw_plrn/*.plrn epw_plrn/plrn_tmp epw_plrn/save \
		epw_plrn/dtau.plrn.xsf

# Cleaning IMAGE final files
	@rm -rf image_*/_ph0 image_*/*.save image_*/*.xml image_*/*.dyn? image_*/*.dyn??  \
                image_*/*.wfc*

# Cleaning ZG final files
	@rm -f zg_conf/equil_pos.txt zg_conf/ZG-*_0.020.dat

# Cleaning TDDFPT final files
	@rm -rf tddfpt_*/*.plot_chi.dat tddfpt_*/*.plot_eps.dat tddfpt_*/out/ tddfpt_*/turbo_spectrum.out
# Cleaning OS-CDFT final files
	@rm -rf oscdft_*/*.out oscdft_*/*.save oscdft_*/*.xml oscdft_*/test* oscdft_*/*.md oscdft_*/*.bfgs oscdft_*/*.mix* oscdft_*/*.wfc* oscdft_*/oscdft.in oscdft_*/*.tmp
# all_currents files
	@for x in `find QEHeat_* -name "test*"`; do rm -rf $$x; done
	@for x in `find QEHeat_* -name "CRASH"`; do rm -rf $$x; done
	@rm -rf QEHeat_*/save \
                QEHeat_*/current_hz*
	@rm -f userconfig


# Calling 'purge' means remove all reference outputs... be careful!
purge: clean
	@for x in `find pw_* -name "benchmark*"`; do rm -rf $$x; done
	@for x in `find cp_* -name "benchmark*"`; do rm -rf $$x; done
	@for x in `find QEHeat_* -name "benchmark*"`; do rm -rf $$x; done


run-tests-serial : run-tests-pw-serial run-tests-cp-serial run-tests-ph-serial run-tests-epw-serial run-tests-hp-serial run-tests-tddfpt-serial run-tests-kcw-serial
	@echo '$@ obsolete, use "make run-tests" instead'
run-tests-pw-serial : run-tests-pw
	@echo '$@ obsolete, use "make run-tests-pw" instead'
run-tests-cp-serial : run-tests-cp
	@echo '$@ obsolete, use "make run-tests-cp" instead'
run-tests-ph-serial : run-tests-ph
	@echo '$@ obsolete, use "make run-tests-ph" instead'
run-tests-epw-serial : run-tests-epw
	@echo '$@ obsolete, use "make run-tests-epw" instead'
run-tests-hp-serial : run-tests-hp
	@echo '$@ obsolete, use "make run-tests-hp" instead'
run-tests-tddfpt-serial : run-tests-tddfpt
	@echo '$@ obsolete, use "make run-tests-tddfpt" instead'
run-tests-kcw-serial : run-tests-kcw
	@echo '$@ obsolete, use "make run-tests-kcw" instead'
run-tests-pp-serial : run-tests-pp
	@echo '$@ obsolete, use "make run-tests-pp" instead'
run-tests-zg-serial : run-tests-zg
	@echo '$@ obsolete, use "make run-tests-zg" instead'

run-tests-parallel : run-tests-pw-parallel run-tests-cp-parallel run-tests-ph-parallel run-tests-epw-parallel run-tests-hp-parallel run-tests-tddfpt-parallel run-tests-kcw-parallel

=== upflib/Makefile ===
# Makefile for upflib

include ../make.inc

MODFLAGS= $(MOD_FLAG)../UtilXlib $(MOD_FLAG).

# list of modules:
# OBJS_NODEP do not depend upon any external modules
# OBJS_DEP   depend upon modules in UtilXlib/
# OBJS_GPU   are GPU-specific

OBJS_DEP= \
atwfc_mod.o \
beta_mod.o \
qrad_mod.o  \
rhoat_mod.o \
rhoc_mod.o \
vloc_mod.o \
qvan2.o \
dqvan2.o \
gen_us_dj.o \
gen_us_dy.o \
init_us_0.o \
init_us_b0.o \
init_us_1.o \
init_us_2_acc.o

OBJS_NODEP= \
atom.o \
atomic_number.o \
dylmr2.o \
gth.o \
paw_variables.o \
pseudo_types.o \
radial_grids.o \
read_cpmd.o \
read_fhi.o \
read_ncpp.o \
read_ps.o \
read_psml.o \
read_upf_new.o \
read_upf_v1.o \
read_uspp.o \
spinor.o \
sph_ind.o \
sph_bes.o \
splinelib.o \
simpsn.o \
upf_auxtools.o \
upf_const.o \
upf_error.o \
upf_invmat.o \
upf_io.o \
upf_ions.o \
upf_kinds.o \
upf_params.o \
upf_parallel_include.o \
upf_spinorb.o \
upf_to_internal.o \
upf_utils.o \
uspp.o \
uspp_param.o \
write_upf_new.o \
xmltools.o \
ylmr2.o

# GPU versions of routines
OBJS_GPU= \
  ylmr2_gpu.o

OBJS_NODEP+= $(OBJS_GPU) dom.o wxml.o

all : libupf.a virtual_v2.x upfconv.x casino2upf.x

libupf.a: $(OBJS_DEP) $(OBJS_NODEP) $(OBJS_GPU)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

# The following utilities are linked with $(OBJS_NODEP) instead of libupf.a
# because the latter has external dependencies that produce "missing symbols"
# errors for some linkers that try to resolve symbols even if never used

virtual_v2.x : virtual_v2.o $(OBJS_NODEP)
	$(LD) $(LDFLAGS) -o $@ virtual_v2.o $(OBJS_NODEP) $(LAPACK_LIBS) $(BLAS_LIBS)

casino2upf.x : casino2upf.o casino_pp.o $(OBJS_NODEP)
	$(LD) $(LDFLAGS) -o $@ casino2upf.o casino_pp.o $(OBJS_NODEP) $(LAPACK_LIBS) $(BLAS_LIBS)
upfconv.x : upfconv.o casino_pp.o $(OBJS_NODEP) 
	$(LD) $(LDFLAGS) -o $@ upfconv.o casino_pp.o $(OBJS_NODEP) $(LAPACK_LIBS) $(BLAS_LIBS)

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L

include make.depend

=== CPV/src/Makefile ===
# Makefile for CP/FPMD

include	../../make.inc

# location of needed modules and included files (if any)
MODFLAGS= $(BASEMOD_FLAGS) 

FOBJS = \
berryion.o \
bforceion.o \
cell_nose.o \
cg.o \
cg_sub.o \
chargedensity.o \
cp_autopilot.o \
cp_emass.o \
cp_interfaces.o \
cp_restart_new.o \
cplib.o \
cpr_mod.o \
cpr.o \
dealloc.o \
dforceb.o \
efermi.o \
efield.o \
eigs0.o \
electrons.o \
electrons_nose.o \
energies.o \
ensemble_dft.o \
environ_cp_module.o \
exch_corr.o \
exx_cg.o \
exx_es.o \
exx_gs.o \
exx_module.o \
exx_pair.o \
exx_psi.o \
exx_vofr.o \
forces.o \
fromscra.o \
gram.o \
gtable.o \
init.o \
init_run.o \
inner_loop_cold.o \
input.o \
ions_nose.o \
ions_positions.o \
ksstates.o \
ldaU_cp.o \
ldaU.o \
ldaUpen.o \
mainvar.o \
cpr_loop.o \
cplib_meta.o \
metaxc.o \
modules.o \
move_electrons.o \
newd.o \
nl_base.o \
nlcc.o \
ortho_base.o \
ortho.o \
phasefactor.o \
plugin_add_potential.o \
plugin_clean.o \
plugin_clock.o \
plugin_energy.o \
plugin_ext_forces.o \
plugin_get_potential.o \
plugin_init_base.o \
plugin_init_cell.o \
plugin_initialization.o \
plugin_init_ions.o \
plugin_int_forces.o \
plugin_print_energies.o \
plugin_print_info.o \
plugin_read_input.o \
plugin_utilities.o \
potentials.o \
pres_ai_mod.o \
print_out.o \
problem_size.o \
pseudo_base.o \
pseudopot.o \
pseudopot_sub.o \
qmatrixd.o \
qqberry.o \
restart.o \
restart_sub.o \
runcp.o \
sic.o \
smallbox.o \
smallbox_grid.o \
smallbox_gvec.o \
smallbox_subs.o \
smallbox_lib.o \
spline.o \
spinsq.o \
stop_run.o \
stress.o \
vol_clu.o \
vofrho.o \
wannier_base.o \
wannier.o \
wave.o \
wave_base.o \
wave_types.o \
wf.o

LOBJS = \
entropy.o 

QEMODS=$(BASEMODS)

TLDEPS= bindir mods

all : tldeps libcp.a manycp.x cp.x wfdd.x cppp.x

manycp.x : manycp.o libcp.a $(QEMODS)
	$(LD) $(LDFLAGS) -o manycp.x manycp.o \
		libcp.a $(QEMODS) $(QELIBS)
	- ( cd ../../bin ; ln -fs ../CPV/src/manycp.x . )

cp.x : cprstart.o libcp.a $(QEMODS)
	$(LD) $(LDFLAGS) -o cp.x cprstart.o \
		libcp.a $(QEMODS) $(QELIBS)
	- ( cd ../../bin ; ln -fs ../CPV/src/cp.x . )

libcp.a : $(FOBJS) $(LOBJS) 
	 $(AR) $(ARFLAGS) $@ $?
	 $(RANLIB) $@

cppp.x : cppp.o $(QEMODS)
	$(LD) $(LDFLAGS) -o cppp.x cppp.o  \
		$(QEMODS) $(QELIBS)
	- (cd ../../bin ; ln -fs ../CPV/src/cppp.x . )

wfdd.x : wfdd.o
	$(LD) $(LDFLAGS) -o $@ wfdd.o $(QEMODS) $(QELIBS)
	- ( cd ../../bin ; ln -fs ../CPV/src/$@ . )

tldeps :
	if test -n "$(TLDEPS)" ; then \
	( cd ../.. ; $(MAKE) $(TLDEPS) || exit 1 ) ; fi

clean :
	- /bin/rm -f cppp.x *.o *.mod *.i core* *_tmp.f90 fort* \
		*.cpp *.d *.L *.a *.s cp.x manycp.x wfdd.x
	-/bin/rm -rf ../../bin/manycp.x ../../bin/cppp.x ../../bin/cp.x ../../bin/wfdd.x

include make.depend

=== EPW/src/Makefile ===
# Makefile for EPW

include ../../make.inc

#
# use recursive definitions in Makefile to modify the PATH for modules
#

MODFLAGS= $(BASEMOD_FLAGS) \
          $(MOD_FLAG)../../PW/src \
          $(MOD_FLAG)../../PHonon/PH \
          $(MOD_FLAG)../../LR_Modules \
          $(MOD_FLAG)../../external/wannier90/src/obj \
          $(MOD_FLAG)../../dft-d3

#
# The above is in alphabetical order except when order matter during compilation
#

EPWOBJS = \
input.o \
ep_constants.o \
global_var.o \
io/io_var.o \
bloch2wannier.o \
utilities/low_lvl.o \
utilities/parallelism.o \
longrange.o \
io/io.o \
io/io_transport.o \
io/io_selfen.o \
wigner.o \
wannier2bloch.o \
wannier2bloch_opt.o \
cumulant.o \
close.o \
printing.o \
utilities/kfold.o \
utilities/bzgrid.o \
io/io_supercond.o \
utilities/utilities.o \
supercond_common.o \
supercond.o \
supercond_iso.o \
supercond_aniso.o \
supercond_coul.o \
utilities/sparse_ir.o \
io/io_sparse_ir.o \
stop.o \
transport_mag.o \
utilities/symmetry.o \
transport_legacy.o \
transport.o \
pw2wan.o \
wannierization.o \
indabs.o \
io/io_indabs.o\
utilities/bcast_input.o \
io/io_ahc.o \
dvqpsi.o \
ep_coarse.o \
ep_coarse_unfolding.o \
supercond_driver.o \
selfen.o \
spectral.o \
wannier.o \
use_wannier.o \
init.o \
readin.o \
setups.o \
summaries.o \
wann_common.o \
polaron.o \
qdabs.o\
wfpt.o \
utilities/screening.o \
#default : epw

PHOBJS = ../../PHonon/PH/libph.a
W90LIB = ../../external/wannier90/libwannier.a
LRMODS = ../../LR_Modules/liblrmod.a
PWOBJS = ../../PW/src/libpw.a ../../KS_Solvers/libks_solvers.a ../../dft-d3/libdftd3qe.a
QEMODS = $(BASEMODS)

TLDEPS= pw ph pp

all : pw ph pp wannier libepw.a epw.x nscf2supercond.x

libepw.a : $(EPWOBJS)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@

epw.x : epw.o libepw.a $(PHOBJS) $(LRMODS) $(PWOBJS) $(W90LIB) $(QEMODS)
	$(LD) $(LDFLAGS) -o $@ \
	epw.o  libepw.a	$(PHOBJS) $(LRMODS) $(W90LIB) $(PWOBJS) $(QEMODS) $(QELIBS)
	- ( cd ../bin ; ln -fs ../src/epw.x . )

nscf2supercond.x : utilities/nscf2supercond.o $(PWOBJS) $(QEMODS)
	$(LD) $(LDFLAGS) -o $@ \
	utilities/nscf2supercond.o ../../PP/src/libpp.a $(PWOBJS) $(QEMODS) $(QELIBS)
	- ( cd ../bin ; ln -fs ../src/$@ . )
	- ( cd ../../bin ; ln -fs ../EPW/src/$@ . )

pw :
	cd ../../ ; make pw

ph :
	cd ../../ ; make ph

pp :
	cd ../../ ; make pp

wannier :
	cd ../../ ; make w90

ld1 :
	cd ../../ ; make ld1

clean :
	- /bin/rm -f  *.o *~ *.d *.mod *.i io/*.mod io/*.o utilities/*.mod utilities/*.o libepw.a liblr.a

include make.depend

=== FFTXlib/src/Makefile ===
# Makefile for FFTXlib

include ../../make.inc

FFTX = \
scatter_mod.o  \
fft_scatter_2d.o  \
fft_scatter_gpu.o  \
fft_scatter_2d_gpu.o  \
fft_ggen.o  \
fft_fwinv.o  \
fft_scalar.o  \
fft_scalar.DFTI.o  \
fft_scalar.ESSL.o  \
fft_scalar.FFTW.o  \
fft_scatter.o  \
fft_scalar.cuFFT.o  \
fftw_interfaces.o  \
fft_scalar.FFTW3.o  \
fft_scalar.SX6.o  \
fft_parallel.o  \
fft_parallel_2d.o  \
fft_interfaces.o  \
fft_interpolate.o \
stick_base.o  \
fftw.o  \
fftw_sp.o  \
fftw_dp.o  \
fft_smallbox.o  \
fft_smallbox_type.o  \
fft_support.o  \
fft_error.o  \
fft_stick.o  \
fft_types.o \
tg_gather.o \
fft_helper_subroutines.o \
fft_param.o \
fft_buffers.o 


all : libqefft.a

libqefft.a: 	$(FFTX)
	$(AR) $(ARFLAGS) $@ $?       
	$(RANLIB) $@    

fft_scalar.o : fft_scalar.f90  fft_scalar.FFTW3.f90  fft_scalar.FFTW.f90  fft_scalar.SX6.f90 fft_scalar.DFTI.f90  fft_scalar.ESSL.f90


fft_stick.o : fft_stick.c fftw_sp.h fftw_dp.h

fftw.o : fftw.c fftw.h

fftw_sp.o : fftw_sp.c fftw_sp.h fftw.h konst.h

fftw_dp.o : fftw_dp.c fftw_dp.h fftw.h konst.h

clean :
	- /bin/rm -f *.o *.a *.d *.i *~ *_tmp.f90 *.mod *.L 

include make.depend

=== GUI/Guib/Makefile ===
VERSION = $(shell cat VERSION)
TMPDIR  = /tmp/Guib-$(VERSION)
HERE    = $(shell pwd)
REPACK  = $(HERE)/sys_utils/repack.sh

# ------------------------------------------------------------------------
#  INDIVIDUAL FILES (per directory)	
# ------------------------------------------------------------------------

ROOT_FILES = \
	README THANKS NEWS INSTALL TODO VERSION ChangeLog \
	BUGS AUTHORS COPYING COPYRIGHT \
	guib  guib.bat  guib.tcl  guib.theme  init.tcl  pkgIndex.tcl 

DOC_FILES = doc/html/*.html doc/usage.pdf

EXAMPLES_FILES = \
	examples/*.tcl \
	examples/*.inp \
	examples/README \
	examples/run.sh

EXTERNAL_FILES = external/

IMAGES_FILES = images/*.gif images/icons.license

SRC_FILES = \
	src/tclIndex \
	src/aindex \
	src/*tcl 

LIB_FILES = \
	lib/tclIndex lib/pkgIndex.tcl \
	lib/tclUtils.tcl lib/tkUtils.tcl


# ------------------------------------------------------------------------
#  FILES grouped by content
# ------------------------------------------------------------------------
GUIB_FILES = \
	$(ROOT_FILES) $(EXAMPLES_FILES) $(IMAGES_FILES) $(SRC_FILES)

LIBS_FILES = $(LIB_FILES) $(EXTERNAL_FILES)

ALL_FILES = $(DOC_FILES) $(GUIB_FILES) $(LIBS_FILES) 

# make nothing by default !!!

default: 
	@echo "Try one of the following:"
	@echo ""
	@echo "make guib-archive       ... makes GUIB *.tgz archive (with documentation)"
	@echo "make guib-archive-nodoc ... makes GUIB *.tgz archive (no documentation)"
	@echo "make clean              ... rm *.tgz *.tar *.tgz *~"
	@echo "make veryclean          ... clean + rm *~ (all directories)"
	@echo ""

guib-archive:
	if test ! -d doc/usage; then cd doc; $(MAKE); fi
	tar --exclude=.svn -cvhf guib.tar $(ALL_FILES)	
	$(REPACK) guib guib-$(VERSION) Guib-$(VERSION)
	rm guib.tar

guib-archive-nodoc:
	tar --exclude=.svn -cvhf guib.tar $(GUIB_FILES) $(LIBS_FILES)
	$(REPACK) guib guib-$(VERSION) Guib-$(VERSION)
	rm guib.tar

clean:
	-cd doc/; $(MAKE) clean
	-rm -f *~
	-rm -f *.tar
	-rm -f *.tar.gz
	-rm -f *.tgz

veryclean: clean
	-for file in `find . | egrep ~$$`; do echo "cleaning ...  $$file"; rm -f $$file; done

=== GWW/gww/Makefile ===
# Makefile for GWW
# Author: G. Stenuit and L. Martin-Samos
#
include ../../make.inc

# location of needed modules
MODFLAGS= $(BASEMOD_FLAGS) \
          $(MOD_FLAG)../pw4gww

GWWOBJS = \
basic_structures.o \
compact_product.o \
contour.o \
create_hf.o \
create_quasi_particle.o \
create_quasi_particle_off.o \
do_contour.o \
do_polarization_lanczos.o \
 do_self_lanczos.o \
do_self_lanczos_time.o \
do_self_lanczos_full.o \
energies_gww.o \
expansion.o \
fft_gw.o \
fit_multipole.o \
fit_polynomial.o \
go_dressed_w.o \
go_exchange.o \
go_fft.o \
go_green.o \
go_polarization.o \
green_function.o \
gv_time.o \
input_gw.o \
lanczos_polarization.o \
para_gww.o \
polarization.o \
read_data_pw.o \
self_energy.o \
self_energy_storage.o \
start_end.o \
times_gw.o \
vcprim.o 


QEMODS = ../../KS_Solvers/libks_solvers.a $(BASEMODS)

LIBMIN= ../minpack/minpacklib.a

TLDEPS=phlibs

all : tldeps gww.x gww_fit.x libgww.a

gww.x : gww.o $(GWWOBJS) $(QEMODS)  $(LIBMIN)
	$(MPIF90) $(LDFLAGS) -o $@ \
		gww.o $(GWWOBJS) $(QEMODS) $(LIBMIN) $(QELIBS)
	- ( cd ../../bin; ln -fs ../GWW/gww/$@ . )

gww_fit.x : gww_fit.o $(GWWOBJS) $(QEMODS) $(LIBMIN)
	$(MPIF90) $(LDFLAGS) -o $@ \
	gww_fit.o $(GWWOBJS) $(QEMODS) $(LIBMIN) $(QELIBS)
	- ( cd ../../bin; ln -fs ../GWW/gww/$@ . )

libgww.a : $(GWWOBJS)
	$(AR) $(ARFLAGS) $@ $(GWWOBJS)

tldeps :
	if test -n "$(TLDEPS)" ; then \
	( cd ../.. ; $(MAKE) $(TLDEPS) || exit 1 ) ; fi

clean :
	- /bin/rm -f -v gww.x gww_fit.x *.o *~ *_tmp.f90 *.d *.mod *.i *.a

include make.depend

# DO NOT DELETE

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=quantum-espresso
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=7.4
pkgrel=1
#_d3q_commit=de4718351e7bbb9d1d12aad2b7ca232d06775b83
_devxlib_commit=a6b89ef77b1ceda48e967921f1f5488d2df9226d
_fox_commit=3453648e6837658b747b895bb7bef4b1ed2eac40
_pw2qmcpack_commit=f72ab25fa4ea755c1b4b230ae8074b47d5509c70
#_qe_gipaw_commit=490046d300ec23444504bfad0562baa1c71f9345
pkgdesc="opEn-Source Package for Research in Electronic Structure, Simulation, and Optimization (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='http://www.quantum-espresso.org/'
msys2_repository_url="https://gitlab.com/QEF/q-e"
msys2_references=(
  'aur: quantum-espresso'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libmbd"
         #"${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-wannier90"
             #"${MINGW_PACKAGE_PREFIX}-environ"
             "git")
source=("https://gitlab.com/QEF/q-e/-/archive/qe-${pkgver}/q-e-qe-${pkgver}.tar.bz2"
        #"d3q::git+https://github.com/anharmonic/d3q#commit=${_d3q_commit}"
        "devxlib::git+https://gitlab.com/max-centre/components/devicexlib#commit=${_devxlib_commit}"
        "fox::git+https://github.com/pietrodelugas/fox#commit=${_fox_commit}"
        "pw2qmcpack::git+https://github.com/QMCPACK/pw2qmcpack#commit=${_pw2qmcpack_commit}"
        #"qe-gipaw::git+https://github.com/dceresoli/qe-gipaw#commit=${_qe_gipaw_commit}"
        "001-use-srand-instead-of-srandom.patch"
        "002-fix-build-devxlib-on-mingw.patch"
        "003-fix-install-c-libraries.patch"
        "004-fix-executable-suffix-on-mingw.patch")
sha256sums=('e17e7090b42db4687c5f304f8a47c3e90a0b05b6e345cdc54727465b5f0b2e33'
            'ef02c13a1ea73f38f0b81edd281c991c25bf045307ceb305f5c0f96b743d1556'
            '8625181b53f2b616a0f704507b4f2381f7b9fabe02078dfb74ab41ee11f5c260'
            'f0f5ebece3f0142e0d0b476db9547d8501de80259bc6409e9b108b887e4cc058'
            '2e18a13c194328516176c2bc2429ac230c9fc585381aa238e586b6034a7df0cb'
            'faaf147678e0c79a6678c5463dd5a466769257968275ef562f40ad1a0c2aacc6'
            'c889430a51d7b910723728c40ca73f183a93db58b1d03b02c6d7c98aea481e8b'
            '918cd94d6c770c88f59836ab4aedde749ac5e78da850556ad1a7acbf99109537')
noextract=("q-e-qe-${pkgver}.tar.bz2")

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  echo "Extracting q-e-qe-${pkgver}.tar.bz2..."
  tar -xjf q-e-qe-${pkgver}.tar.bz2 || true

  for _ext_prj in devxlib fox pw2qmcpack; do
    mv ${_ext_prj} q-e-qe-${pkgver}/external/
  done

  cd "${srcdir}"/q-e-qe-${pkgver}
  apply_patch_with_msg \
    001-use-srand-instead-of-srandom.patch \
    002-fix-build-devxlib-on-mingw.patch \
    003-fix-install-c-libraries.patch \
    004-fix-executable-suffix-on-mingw.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    export FFLAGS=" -Wno-missing-include-dirs -w"
  fi

  CFLAGS+=" -Wno-incompatible-pointer-types" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -DQE_ENABLE_FOX=ON \
      -DQE_ENABLE_HDF5=ON \
      -DQE_ENABLE_OPENMP=ON \
      -DQE_ENABLE_ENVIRON=OFF \
      -DQE_ENABLE_LIBXC=OFF \
      -DQE_ENABLE_MPI=OFF \
      -DQE_ENABLE_TEST=OFF \
      -DQE_ENABLE_PLUGINS="pw2qmcpack;legacy" \
      -DQE_DEVICEXLIB_INTERNAL=ON \
      -DQE_FOX_INTERNAL=ON \
      -DQE_MBD_INTERNAL=OFF \
      -DQE_WANNIER90_INTERNAL=OFF \
      -DQE_FFTW_VENDOR="FFTW3" \
      -DBLA_VENDOR=OpenBLAS \
      -S q-e-qe-${pkgver} \
      -B build-${MSYSTEM}

  "${MINGW_PREFIX}"/bin/cmake.exe --build build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install build-${MSYSTEM}

  install -Dm644 "${srcdir}"/q-e-qe-${pkgver}/License \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/qe/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done

  # Rename cp to qe_cp, to not be used instead of /usr/bin/cp to copy files 
  mv "${pkgdir}${MINGW_PREFIX}"/bin/{cp,qe_cp}.exe
}
